//
//  AEOpener.m
//  AliExpress-Cordova
//
//  Created by  Maxim Bogdanov on 18.05.2017.
//
//

#import "AEOpener.h"

@interface AEOpener()
@property (nonatomic, strong) NSString *callbackID;
@end

@implementation AEOpener
    
- (void)open:(CDVInvokedUrlCommand *)command
{
    self.callbackID = command.callbackId;
    NSURL *url;
    if (command.arguments.count > 0) {
        NSString *urlString = [NSString stringWithFormat:@"aliexpress://goto?url=%@", [command.arguments objectAtIndex:0]];
        url = [NSURL URLWithString:urlString];
    }
    if (url) {
        __weak AEOpener *weakSelf = self;
        [self.commandDelegate runInBackground:^{
            BOOL result = [[UIApplication sharedApplication] openURL:url];
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [weakSelf sendResultSuccess:result errorMessage:(result) ? nil : [NSString stringWithFormat:@"AliExpressOpener: Cannot open URL [%@]", url.absoluteString]];
            });
        }];
    }
    else {
        [self sendResultSuccess:NO errorMessage:@"AliExpressOpener: No URL specified"];
    }
}
    
- (void)sendResultSuccess:(BOOL)success errorMessage:(NSString *)errorMessage
{
    CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:(success ? CDVCommandStatus_OK : CDVCommandStatus_ERROR) messageAsString:errorMessage];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
}

@end
